﻿Option Strict Off
Option Explicit On

Module Demo_wwio
    ' Dne 28.3.2009
    ' By HaCeSOFT
    ' Pavel Prochazka
    ' hacesoft@mujmail.cz
    ' www.prochazka.zde.cz

    Public Structure PORT_CONFIG
        Dim DMA As Integer
        Dim IRQ As Integer
        Dim Type_Port As Integer
        Dim adress As Integer
        Dim range As Integer
        Dim port As String
    End Structure

    Private Structure strucEXISTING_DRIVER
        Dim DriverInstall As UInteger
        Dim DriverStart As UInteger
    End Structure

    Private Structure RETURN_CODE
        Dim r_OpenSCManager As Boolean
        Dim r_DriverStop As Boolean
        Dim r_DriverRemove As Boolean
        Dim r_RegDeleteKey As Boolean
        Dim r_Existing_Driver As Boolean
        Dim r_UnLock As Boolean
        Dim r_Lock As Boolean
    End Structure
    Private Declare Function Lock_ Lib "wwio.dll" (ByRef ReturnCode As RETURN_CODE) As UInteger 'Zavre giveio.sys ovladac.
    Private Declare Function UnLock_ Lib "wwio.dll" () As Integer 'Otevre giveio.sys ovladac.
    Private Declare Function Existing_Driver Lib "wwio.dll" (ByRef ExistingDriver As strucEXISTING_DRIVER) As Integer

    Private Declare Function OpenPort Lib "wwio.dll" (ByRef Port_Config As PORT_CONFIG) As Integer REM zjisti parametry dotazovaneho portu

    Private Declare Function Write Lib "wwio.dll" (ByVal Port As Integer, ByVal Data As Byte) As Integer
    Private Declare Function Write_Data Lib "wwio.dll" (ByVal Data As Byte) As Integer
    Private Declare Function Write_Status Lib "wwio.dll" (ByVal Data As Byte) As Integer
    Private Declare Function Write_Control Lib "wwio.dll" (ByVal Data As Byte) As Integer

    Private Declare Function Read Lib "wwio.dll" (ByVal Port As Short) As Integer
    Private Declare Function Read_Data Lib "wwio.dll" () As Integer
    Private Declare Function Read_Status Lib "wwio.dll" () As Integer
    Private Declare Function Read_Control Lib "wwio.dll" () As Integer

    Private Declare Function ErrorEx Lib "wwio.dll" (ByVal text As String) As Integer
    Private Declare Function Error_ Lib "wwio.dll" () As Integer
    Private Declare Function Wait Lib "wwio.dll" (ByVal delka As Short) As Integer
    Private Declare Function WaitEx Lib "wwio.dll" (ByVal delka As Short) As Integer

    Sub Main()
        Dim rnt As Integer
        Dim rnt1 As Integer
        Dim Port_Config As PORT_CONFIG
        Dim ExistingDriver As strucEXISTING_DRIVER

        Dim Reg As String = 255
        Dim Data As Integer
        Dim k As Integer
        Dim title As String
        Dim adresa As Integer

        Port_Config.range = 0
        Port_Config.port = "LPT1"
        REM title = My.Application.Info.Title
        title = "Demo WwIo.Dll"

        k = UnLock_()
        rnt = Unlock_Hlaseni(Error_(), title)
        rnt1 = Existing_Driver(ExistingDriver)
        If k = 0 Then
            If rnt1 = 1 Then REM fnkce se provedla v spravne
                If rnt = 1 Then
                    REM zde se vypise presny stav ovladace giveio.sys
                    MsgBox("Zde se podivejte do MSDN libraty na funkci CreateService ktera vrátila tuto hodnotu:" & ExistingDriver.DriverInstall, MsgBoxStyle.OkOnly + MsgBoxStyle.Information, title)
                    MsgBox("Zde se podivejte do MSDN libraty na funkci StartService ktera vrátila tuto hodnotu:" & ExistingDriver.DriverStart, MsgBoxStyle.OkOnly + MsgBoxStyle.Information, title)
                End If
            End If
            If k = 0 Then

                'rnt = Cekat(10000) 'Cekat 10s - Jedna se o presnou cekaci rutinu, ktera vytizi procesor na 100%!
                'rnt = CekatEx(10000) 'Cekat 10s - Tato funkce pouziva multimedialni timer, po celou dobu cekani se nezatezuje procesor.
                '********************************************************************************
                'Zapise hodnotu 1 na adresu LPT1 + Base0.

                rnt = OpenPort(Port_Config)
                OpenPort_hlaseni(rnt, Port_Config, title)
                If rnt = 0 Then REM vse je ok.
                    Data = 1
                    adresa = Write_Data(Data)
                    WriteRead_Hlaseni(Error_(), title)
                    If Error_() = 0 Then
                        MsgBox("Hodnotu: $" & Hex(Data) & " jsem zapsal na adresu: $" & Hex(adresa), MsgBoxStyle.OkOnly + MsgBoxStyle.Information, title)
                    End If

                    'Zjisti typ portu:
                    'return 2 -> jednase o port SPP nebo EPP
                    'return 4 -> jedna se o port ECP a jeho kombinace
                    rnt = Port_Config.Type_Port
                    If rnt <> -1 Then
                        If rnt = 2 Then
                            MsgBox("Port " & Port_Config.port & " je typu SPP nebo EPP.", MsgBoxStyle.OkOnly + MsgBoxStyle.Information, title)
                        End If
                        If rnt = 4 Then
                            MsgBox("Port " & Port_Config.port & " je typu ECP.", MsgBoxStyle.OkOnly + MsgBoxStyle.Information, title)
                        End If
                    End If

                    'Zjisti IRQ portu.
                    rnt = Port_Config.IRQ
                    If rnt <> -1 Then
                        MsgBox("Port " & Port_Config.port & " používá IRQ číslo: " & Hex(rnt), MsgBoxStyle.OkOnly + MsgBoxStyle.Information, title)
                    End If

                    'Zjisti DMA portu.
                    'pokud je port typu SPP nebo EPP tak DMA prenosy nejdou uskutecnit!
                    rnt = Port_Config.DMA
                    If rnt <> -1 Then
                        MsgBox("Port " & Port_Config.port & " používá DMA číslo: " & Hex(rnt), MsgBoxStyle.OkOnly + MsgBoxStyle.Information, title)
                    Else
                        MsgBox("Port " & Port_Config.port & " je typu SPP nebo EPP a tudiz neexistuje DMA!!!", MsgBoxStyle.OkOnly + MsgBoxStyle.Information, title)
                    End If

                    'Precte hodnotu z adresy LPT1 + Base0 a ulozi do promenne k.
                    k = Read_Data()
                    WriteRead_Hlaseni(Error_(), title)
                    If Error_ = 0 Then
                        MsgBox("Z požadované adresy ($" & Hex(adresa) & ") jsem přečetl hodnotu: $" & Hex(k), MsgBoxStyle.OkOnly + MsgBoxStyle.Information, title)
                    End If
                End If
                '********************************************************************************
                Port_Config.range = 0
                Port_Config.port = "Com1"

                rnt = OpenPort(Port_Config)
                OpenPort_hlaseni(rnt, Port_Config, title)
                If rnt = 0 Then
                    MsgBox("Port " & Port_Config.port & " má adresu: $" & Hex(Port_Config.adress), MsgBoxStyle.OkOnly + MsgBoxStyle.Information, title)
                End If
                '********************************************************************************
                ' Ted budem pracovat s portem LPT2!!!.
                Port_Config.range = 0
                Port_Config.port = "Lpt2"

                rnt = OpenPort(Port_Config)
                OpenPort_hlaseni(rnt, Port_Config, title)
                'Standartne na PC LPT2 neni, tudis vrati hodnotu -1.
                If rnt = 0 Then
                    MsgBox("Port " & Port_Config.port & " má adresu: $" & Hex(rnt), MsgBoxStyle.OkOnly + MsgBoxStyle.Information, title)

                    'Zapise hodnotu 255 na adresu LPT2 + Base0.
                    Data = 255
                    adresa = Write_Data(Data)
                    WriteRead_Hlaseni(Error_(), title)
                    If Error_() = 0 Then
                        MsgBox("Hodnotu: $" & Hex(Data) & " jsem zapsal na adresu: $" & Hex(adresa), MsgBoxStyle.OkOnly + MsgBoxStyle.Information, title)
                    End If

                    'Precte hodnotu z adresy LPT2 + Base0 a ulozi do promenne k.
                    ' nasledujici prikaz precte hodnotu 255 z LPT1!
                    k = Read_Data()
                    WriteRead_Hlaseni(Error_(), title)
                    If Error_() = 0 Then
                        MsgBox("Z požadované adresy (" & adresa & "+ Base0) jsem přečetl hodnotu: $" & Hex(k), MsgBoxStyle.OkOnly + MsgBoxStyle.Information, title)
                    End If
                End If
                '********************************************************************************
                'Po ukonceni prace s porty.
                Dim ReturnCode As RETURN_CODE

                k = Lock_(ReturnCode)
                REM k = Lock_()
                Lock_Hlaseni(k, title)
            End If
        End If
    End Sub

    Sub OpenPort_hlaseni(ByVal rnt As Integer, ByRef Port_Config As PORT_CONFIG, ByRef title As String)
        REM // ErrorKod = 0 -- Vse je ok.
        REM // ErrorKod = 1 -- Paramet range mimo rozsah.
        REM // ErrorKod = 2 -- Pozadovaný port NEEXISTUJE.
        REM // ErrorKod = 3 -- Neplatne oznaceni portu.
        REM // ErrorKod = 4 -- Je indikovana chyba z predchozi cinnosti funkce OpenPort.
        REM // ErrorKod = 5 -- Neni provedena funkce UnLock.
        If rnt = 1 Then
            MsgBox("Parametr range Portu " & Port_Config.port & " je mimo dovolený rozsah!", MsgBoxStyle.OkOnly + MsgBoxStyle.Critical, title)
        ElseIf rnt = 2 Then
            MsgBox("Požadovaný port " & Port_Config.port & " neexistuje!", MsgBoxStyle.OkOnly + MsgBoxStyle.Critical, title)
        ElseIf rnt = 3 Then
            MsgBox("Parametr " & Port_Config.port & " není platné označení fyzického portu!", MsgBoxStyle.OkOnly + MsgBoxStyle.Critical, title)
        ElseIf rnt = 4 Then
            MsgBox("Je indikována chyba z předchozi činnosti funkce OpenPort", MsgBoxStyle.OkOnly + MsgBoxStyle.Critical, title)
        ElseIf rnt = 5 Then
            MsgBox("Před použitím funkce OpenPort prosim nejprve použijte funkci UnLock", MsgBoxStyle.OkOnly + MsgBoxStyle.Critical, title)
        End If
    End Sub

    Function Unlock_Hlaseni(ByVal rnt As Integer, ByRef title As String)
        REM //ErrorKod = 0 -- Vše je OK.
        REM //ErrorKod = -1 -- Funkce selhala.
        REM //ErrorKod = 1 -- Nelze najit soubor GiveIO.sys.
        REM //ErrorKod = 2 -- Nejde nainstalovat giveio.sys ovladač.
        REM //ErrorKod = 3 -- Nejde spustit giveio.sys ovladač.
        REM //ErrorKod = 4 -- Nejde otevrit OpenSCManager.
        REM //ErrorKod = 12 -- ERROR_FILE_NOT_FOUND, toto je chyba funkce DriverStart, provedte restart pc a smazte v registrech retezec giveio
        REM //ErrorKod = 13 -- ERROR_PATH_NOT_FOUND, toto je chyba funkce DriverStart, provedte restart pc a smazte v registrech retezec giveio
        REM //ErrorKod = 183 – Nelze vytvořit soubor, který již existuje. Nejedna se o chybu ale o upozorněni, program muže pokračovat dále.
        REM //ErrorKod = 1072 – Zadané zařízení je určeno na odstranění. Zkuste to znovu.
        REM //ErrorKod = 1073 – Zadaná služba již existuje. Nejedna se o chybu ale o upozorněni, program muže pokračovat dále.
        REM //ErrorKod = 1056 - Instance této služby je již spuštěna. Nejedna se o chybu ale o upozorněni, program muže pokračovat dále.
        Unlock_Hlaseni = 0
        Select Case rnt
            Case -1
                MsgBox("Funkce UnLock selhala", MsgBoxStyle.OkOnly + MsgBoxStyle.Critical, title)
                Unlock_Hlaseni = 1
            Case 1
                MsgBox("Nelze najít soubor GiveIo.sys", MsgBoxStyle.OkOnly + MsgBoxStyle.Critical, title)
            Case 2
                MsgBox("Nejde nainstalovat GiveIo.sys", MsgBoxStyle.OkOnly + MsgBoxStyle.Critical, title)
            Case 3
                MsgBox("Nejde spustit GiveIo.sys", MsgBoxStyle.OkOnly + MsgBoxStyle.Critical, title)
                Unlock_Hlaseni = 1
            Case 4
                MsgBox("Nejde otevrit OpenSCManager" + Chr(13) _
                       + "V UAC nastavte execution level na reqire Administrator, toto se hlavne tika WinVista " + Chr(13) _
                       , MsgBoxStyle.OkOnly + MsgBoxStyle.Critical, title)
            Case 12
                MsgBox("Funkce DriverStárt hlasi: ERROR_FILE_NOT_FOUND" + Chr(13) _
                       + "toto je chyba funkce DriverStart, provedte restart pc a smazte v registrech retezec giveio" _
                       , MsgBoxStyle.OkOnly + MsgBoxStyle.Critical, title)
                Unlock_Hlaseni = 1
            Case 13
                MsgBox("Funkce DriverStárt hlasi: ERROR_PATH_NOT_FOUND" + Chr(13) _
                       + "toto je chyba funkce DriverStart, provedte restart pc a smazte v registrech retezec giveio" _
                       , MsgBoxStyle.OkOnly + MsgBoxStyle.Critical, title)
                Unlock_Hlaseni = 1
            Case 183
                MsgBox("Nelze vytvořit soubor, který již existuje. Nejedna se o chybu ale o upozorněni, program muže pokračovat dále.", MsgBoxStyle.OkOnly + MsgBoxStyle.Critical, title)
                Unlock_Hlaseni = 1
            Case 1072
                MsgBox("Zadané zařízení je určeno na odstranění. Zkuste to znovu", MsgBoxStyle.OkOnly + MsgBoxStyle.Critical, title)
                Unlock_Hlaseni = 1
            Case 1073
                MsgBox("Zadaná služba již existuje. Nejedna se o chybu ale o upozorněni, program muže pokračovat dále.", MsgBoxStyle.OkOnly + MsgBoxStyle.Critical, title)
                Unlock_Hlaseni = 1
            Case 1056
                MsgBox("Instance této služby je již spuštěna. Nejedna se o chybu ale o upozorněni, program muže pokračovat dále.", MsgBoxStyle.OkOnly + MsgBoxStyle.Critical, title)
                Unlock_Hlaseni = 1
        End Select
    End Function

    Sub WriteRead_Hlaseni(ByVal rnt As Integer, ByRef title As String)
        REM //ErrorKod = 0 -- Vše je OK.
        REM //ErrorKod = 1 -- Zápis se neprovedl, nelze otevřít giveio.sys ovladač. Selhala funkce CreateFile, nebo jse neprovedli funkci UnLock(); 
        REM //ErrorKod = 2 -- Zápis se neprovedl, je spatná adresa.
        REM //ErrorKod = 3 -- Je indikovana chyba z predchozi cinnosti funkce OpenPort
        Select Case rnt
            Case 1
                MsgBox("Zápis se neprovedl, nelze otevřít giveio.sys ovladač. Selhala funkce CreateFile, nebo jse neprovedli funkci UnLock()", MsgBoxStyle.OkOnly + MsgBoxStyle.Critical, title)
            Case 2
                MsgBox("Zápis se neprovedl, je spatná adresa.", MsgBoxStyle.OkOnly + MsgBoxStyle.Critical, title)
            Case 3
                MsgBox("Je indikovana chyba z predchozi cinnosti funkce OpenPort", MsgBoxStyle.OkOnly + MsgBoxStyle.Critical, title)
        End Select
    End Sub

    Sub Lock_Hlaseni(ByVal rnt As Integer, ByRef title As String)
        REM typedef struct {//Registr provedeni funkci pri ukoncovani prace s ovladacem giveio.sys
        REM unsigned r_OpenSCManager : 1; /*bit 0 -->  */
        REM unsigned r_DriverStop : 1; /*bit 1 -->  */
        REM unsigned r_DriverRemove : 1; /*bit 2 -->  */
        REM unsigned r_RegDeleteKey : 1; /*bit 3 -->  */
        REM unsigned r_Existing_Driver : 1; /*bit 4 -->  */
        REM unsigned r_UnLock : 1; /*bit 5 -->  */
        REM unsigned r_Lock : 1; /*bit 6 -->  */
        REM }RETURN_CODE;

        REM rc_OpenSCManager 0x1 //hodnota je true, kdyz nelze uspesbě použít funkci OpenSCManager
        REM rc_DriverStop 0x2 //hodnota je true, když nelze zastavit giveio.sys ovladač (nejaký další program ho používá)
        REM rc_DriverRemove 0x4 //hodnota je true, když nelze odstranit giveio.sys ovladač (nejaký další program ho používá)
        REM rc_RegDeleteKey 0x8 //hodnota je true, když nelze uklidit systemové registry
        REM rc_Existing_Driver 0x10 //hodnota je true, když selhala funkce Existing_Driver
        REM rc_UnLock 0x20 //hodnota je true, když není provedena funkce Unlock
        REM rc_Lock 0x40 //hodnota je true, když už jednou jste použily funkci Lock

        If rnt <> 0 Then
            MsgBox("Když navratová hodnta není nula neznamená že se něco pokazilo" + Chr(13) _
                   + "Hodnotu " & rnt & " je potreba analizovat na binarní urovni:" + Chr(13) _
                   + "typedef struct {//Registr provedeni funkci pri ukoncovani prace s ovladacem giveio.sys" + Chr(13) _
                    + "unsigned r_OpenSCManager : 1; /*bit 0 -->  hodnota je true, kdyz nelze uspešně použít funkci OpenSCManager */" + Chr(13) _
                    + "unsigned r_DriverStop : 1; /*bit 1 -->  hodnota je true, když nelze zastavit giveio.sys ovladač (nejaký další program ho používá) */" + Chr(13) _
                    + "unsigned r_DriverRemove : 1; /*bit 2 -->  hodnota je true, když nelze odstranit giveio.sys ovladač (nejaký další program ho používá) */" + Chr(13) _
                    + "unsigned r_RegDeleteKey : 1; /*bit 3 -->  hodnota je true, když nelze uklidit systemové registry */" + Chr(13) _
                    + "unsigned r_Existing_Driver : 1; /*bit 4 -->  hodnota je true, když selhala funkce Existing_Driver */" + Chr(13) _
                    + "unsigned r_UnLock : 1; /*bit 5 -->  hodnota je true, když není provedena funkce Unlock */" + Chr(13) _
                    + "unsigned r_Lock : 1; /*bit 6 -->  hodnota je true, když už jednou jste použily funkci Lock */" + Chr(13) _
                    + "}RETURN_CODE;" + Chr(13), MsgBoxStyle.OkOnly + MsgBoxStyle.Information, title)
        End If
    End Sub
End Module